#include <config.h>
#define _GNU_SOURCE
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
static const char spred_bibliography_arr[] =
"---\n"
"Goedecker2004:\n"
"  JOURNAL_REF: 'J. Chem. Phys. 120, 9911–9917 (2004)'\n"
"  BIBTEX_REF: |\n"
"    @Article{Goedecker2004,\n"
"    Title                    = {{M}inima hopping: {A}n efficient search method for the global minimum of the potential energy surface of complex molecular systems},\n"
"    Author                   = {{G}oedecker, {S}.},\n"
"    Journal                  = {The Journal of chemical physics},\n"
"    Year                     = {2004},\n"
"    \n"
"    Month                    = jun,\n"
"    Number                   = {21},\n"
"    Pages                    = {9911--9917},\n"
"    Volume                   = {120},\n"
"    \n"
"    Doi                      = {10.1063/1.1724816}\n"
"    }\n"
"  DESCRIPTION: Seminal paper of Minima Hopping Method\n"
"Schaefer2014:\n"
"  JOURNAL_REF: J. Chem. Phys. 140, 214102 (2014)\n"
"  BIBTEX_REF: |\n"
"    @article{Schaefer2014,\n"
"    title                    = {Minima hopping guided path search: An efficient method for finding complex chemical reaction pathways},\n"
"    author                   = {Schaefer, Bastian and Mohr, Stephan and Amsler, Maximilian and Goedecker, Stefan},\n"
"    year                     = {2014},\n"
"    \n"
"    month                    = june, \n"
"    \n"
"    Journal                  = {The Journal of Chemical Physics},\n"
"    volume                   = {140},\n"
"    number                   = {21}, \n"
"    pages                    = {214102},\n"
"    doi                      = {10.1063/1.4878944}\n"
"    }\n"
"  DESCRIPTION: Minima Hopping guided Path Search Method, reference paper\n"
"Schaefer2015:\n"
"  JOURNAL_REF: J. Chem. Phys. 142, 034112 (2015)\n"
"  BIBTEX_REF: |\n"
"    @article{Schaefer2015,\n"
"    title   = {{S}tabilized {Q}uasi-{N}ewton {O}ptimization of {N}oisy {P}otential {E}nergy {S}urfaces},\n"
"    author  = {Schaefer, Bastian and Ghasemi, S. Alireza and Roy, Shantanu and Goedecker, Stefan},\n"
"    year    = {2015},\n"
"\n"
"    month   = jan,\n"
"\n"
"    Journal  = {The Journal of Chemical Physics},\n"
"    volume = {142},\n"
"    number = {3},\n"
"    pages   = {034112},\n"
"\n"
"    Arxivid = {arXiv:1412.0935},\n"
"    doi = {10.1063/1.4905665}\n"
"    }\n"
"  DESCRIPTION: Geometry optimizers tailored for electronic structure calculations\n"
  ;
void FC_FUNC_(get_spred_bibliography, GET_SPRED_BIBLIOGRAPHY)(char* db_ptr,int* db_len)
{
  if (*db_len==0)
    {
    *db_len=strlen(spred_bibliography_arr);
    return;
    }
  else
    {
      memcpy(db_ptr,spred_bibliography_arr, sizeof(char) * (*db_len));
    }
}
